Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2479 by niro, Wed Jan 8 10:24:48 2014 UTC revision 2941 by niro, Mon Jun 13 12:13:22 2016 UTC
# Line 9  Line 9 
9    
10  # setup locales  # setup locales
11  TEXTDOMAIN=installer  TEXTDOMAIN=installer
 LC_MESSAGES=C  
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
# Line 41  do Line 40  do
40   fi   fi
41  done  done
42    
43  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  # fetch cmdline
44  # -> now in images.conf  for argv in $*
45  CDIMAGENAME=""  do
46  TOTALLINES=""   case $1 in
47  CURRENTLINE=0   --liveroot) shift; cmdliveroot="$1" ;;
48  if [ -e /mnt/cdrom/system/images.conf ]   --imageroot) shift; cmdimageroot="$1" ;;
49  then   --installroot) shift; cmdinstallroot="$1" ;;
50   source /mnt/cdrom/system/images.conf   --filesystem) shift; cmdformatfilesystem="$1" ;;
51   # check if all required variables are set   --help)
52   [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"   echo "$0 options:"
53   [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"   echo " --liveroot [path]     - override default liveroot"
54  else   echo " --imageroot [path]    - override default imageroot"
55   die "/mnt/cdrom/system/images.conf not found"   echo " --installroot [path]  - override default installroot"
56  fi   echo " --filesystem [fstype] - override default filesystem used to format the disk"
57     exit 0 ;;
58     esac
59     shift
60    done
61    
62  ### System/Config Version  ### System/Config Version
63  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
64  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
65    
66    # initialize global variables so they are exportable
67  # some sane defaults  # some sane defaults
68  CDROOT="${DEFAULT_CDROOT}"  INSTALL_METHOD=""
69  INSTALLROOT="${DEFAULT_INSTALLROOT}"  if [[ -n ${cmdliveroot} ]]
70    then
71     LIVEROOT="${cmdliveroot}"
72    else
73     LIVEROOT="${DEFAULT_LIVEROOT}"
74    fi
75    if [[ -n ${cmdimageroot} ]]
76    then
77     IMAGEROOT="${cmdimageroot}"
78    else
79     IMAGEROOT="${DEFAULT_IMAGEROOT}"
80    fi
81    if [[ -n ${cmdinstallroot} ]]
82    then
83     INSTALLROOT="${cmdinstallroot}"
84    else
85     INSTALLROOT="${DEFAULT_INSTALLROOT}"
86    fi
87  KERNELPKG="${DEFAULT_KERNELPKG}"  KERNELPKG="${DEFAULT_KERNELPKG}"
88  KERNELOPTS="${DEFAULT_KERNELOPTS}"  KERNELOPTS="${DEFAULT_KERNELOPTS}"
89  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
# Line 70  GRUB2OPTS="" Line 91  GRUB2OPTS=""
91  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
92  SPECIALDEVICE=""  SPECIALDEVICE=""
93  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
94  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  if [[ -n ${cmdformatfilesystem} ]]
95    then
96     FORMAT_FILESYSTEM="${cmdformatfilesystem}"
97    else
98     FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
99    fi
100    FLASHDISK=0
101    
102  #################################################  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
103  #  DIALOG BOXEN #  # -> now in images.conf
104  #################################################  CDIMAGENAME=""
105    TOTALLINES=""
106    CURRENTLINE=0
107    if [ -e ${IMAGEROOT}/images.conf ]
108    then
109     source ${IMAGEROOT}/images.conf
110     # check if all required variables are set
111     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
112     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
113    else
114     die "${IMAGEROOT}/images.conf not found"
115    fi
116    
117    ### helper scripts ###
118    
119  trap_exit()  trap_exit()
120  {  {
# Line 83  trap_exit() Line 123  trap_exit()
123   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
124   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
125   is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}   is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
126     [[ -n ${SWAPHDD} ]] && swapoff ${SWAPHDD}
127    
128   echo $"Installation aborted."   echo $"Installation aborted."
129   exit 1   exit 1
130  }  }
131    
132  dialog_die()  install_meter()
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
133  {  {
134   local retval   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
135     do
136   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"   CURRENTLINE=$(grep -c . /tmp/install.log)
137   retval=$?   PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
138   if [[ ${retval} -eq 1 ]]   echo ${PERCENT}
139   then   sleep 1
140   clear   done
141   echo $"The process was aborted."   rm -f /tmp/install.log
142   exit 1   return 0
  fi  
143  }  }
144    
145  task_setup_system_menu()  mount_rootfs()
146  {  {
  local mode  
147   local retval   local retval
148    
149   mode="$(dialog_setup_system_menu)"   if [[ -n ${SWAPHDD} ]]
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
150   then   then
151   case "${mode}" in   swapon ${SWAPHDD} || dialog_die $"Could not enable swap space '${SWAPHDD}'"
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") task_setup_system_menu;;  
  esac  
152   fi   fi
 }  
   
 dialog_hardware_detection()  
 {  
  local message  
153    
154   run_hardware_detection_disks   if [[ -n ${ROOTHDD} ]]
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
155   then   then
156   for i in ${ALL_DISKS}   if is_mounted --location "${INSTALLROOT}"
157   do   then
158   message+="\Z3${i}\Zn "   echo $"${INSTALLROOT} already mounted" >&2
159   done   else
160   message+="\n"   mount -t "${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
161   fi   fi
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  message+="\n"  
  message+=$"Optical disk drives:\n"  
  for i in ${ALL_CDROMS}  
  do  
  message+="\Z3${i}\Zn"  
  done  
  message+="\n"  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"  
162   fi   fi
163    
164   messagebox -y 12 -h $"Detected hardware:" "${message}"   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
 }  
   
 task_setup_hdd_partitions_manual()  
 {  
  local i  
  local retval  
165    
166   if [[ -z ${ALL_DISKS} ]]   if [[ -n ${BOOTHDD} ]]
167   then   then
168   dialog_no_harddrive_found   if is_mounted --location "${INSTALLROOT}"/boot
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
169   then   then
170   dialog_setup_hdd_info   echo $"${INSTALLROOT}/boot already mounted" >&2
171   setup_hdd_partitions_manual   else
172     mount -t "${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" "${INSTALLROOT}"/boot || dialog_die $"Could not mount bootfs - drive '${BOOTHDD}' -> '${INSTALLROOT}/boot'"
173   fi   fi
174   fi   fi
175  }  }
176    
177  task_setup_hdd_partitions_auto()  umount_rootfs()
178  {  {
179   local i   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
180   local retval   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
181    
182   if [[ -z ${ALL_DISKS} ]]   if [[ -n ${SWAPHDD} ]]
183   then   then
184   dialog_no_harddrive_found   swapoff ${SWAPHDD} || die
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
185   fi   fi
186  }  }
187    
188  install_meter()  install_do_reboot()
 {  
  while [[ ${CURRENTLINE} != ${TOTALLINES} ]]  
  do  
  CURRENTLINE=$(grep -c . /tmp/install.log)  
  PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))  
  echo ${PERCENT}  
  sleep 1  
  done  
  rm -f /tmp/install.log  
  return 0  
 }  
   
 task_main()  
189  {  {
190   local method=0   reboot
  local retval  
   
  while [[ ${method} -le 2 ]]  
  do  
  method=$(dialog_main)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && exit 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case ${method} in  
  "1") task_setup_system_menu ;;  
  "2") dialog_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
191  }  }
192    
 #################################################  
 # Install Komandos #  
 #################################################  
193  run_hardware_detection()  run_hardware_detection()
194  {  {
195   local hwinfo   local hwinfo
   
196   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
197    
198   ## check for special devices/clients:   # check for special devices/clients:
199   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
200   #local removable=0   local removable=0
201   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
202   #then   then
203   #for i in /sys/block/[hs]d*/removable   for i in /sys/block/[hs]d*/removable
204   #do   do
205   #if [[ $(< ${i}) = 1 ]]   if [[ $(< ${i}) = 1 ]]
206   #then   then
207   #removable=1   removable=1
208   #fi   # we assume that all removable disks are flash disks on a zotac
209   #done   export FLASHDISK=1
210   ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'   fi
211     done
212   ## only add this for grub legacy, grub2 detect these settings on its own   # smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
213   #export GRUBLEGACYOPTS="rootdelay=8"  
214   ## there are to zotac types in the wild, nvidia based gfx and intel   # only add this for grub legacy, grub2 detect these settings on its own
215   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   export GRUBLEGACYOPTS="rootdelay=8"
216   #then   # there are to zotac types in the wild, nvidia based gfx and intel
217   #export SPECIALDEVICE="zotac_nvidia"   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
218   #else   then
219   #export SPECIALDEVICE="zotac_intel"   export SPECIALDEVICE="zotac_nvidia"
220   #fi   else
221   #fi   export SPECIALDEVICE="zotac_intel"
222     fi
223     fi
224    
225   # check for special devices/clients:   # check for special devices/clients:
226   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 302  run_hardware_detection() Line 240  run_hardware_detection()
240   export GRUBLEGACYOPTS=""   export GRUBLEGACYOPTS=""
241   fi   fi
242    
243     # check for i845 Chipsets and enable KMS and use 915 drm driver later in initrd
244     if [[ ! -z $(echo "${hwinfo}" | grep -i i845) ]]
245     then
246     export SPECIALDEVICE="i845"
247     # unset default video=1024x768 opt or the drm driver breaks
248     export KERNELOPTS="quiet"
249     export GRUBLEGACYOPTS=""
250     # enable full kms support
251     export GRUB2GFXPAYLOAD="keep"
252     fi
253    
254     # check for radeon gfxcards
255     if [[ ! -z $(echo "${hwinfo}" | grep -i radeon) ]]
256     then
257     # enable full kms support
258     export GRUB2GFXPAYLOAD="keep"
259     fi
260    
261     # requires nomsi to prevent massive IRQ error spam
262     # see: http://ubuntuforums.org/showthread.php?t=1234983
263     if [[ ! -z $(echo "${hwinfo}" | grep -i 'P5VD2-X') ]] || [[ ! -z $(echo "${hwinfo}" | grep -i 'VT8237') ]] || [[ ! -z $(echo "${hwinfo}" | grep -i 'VX700') ]]
264     then
265     export SPECIALDEVICE="nomsi"
266     export KERNELOPTS="${KERNELOPTS} pci=nomsi,noaer"
267     fi
268    
269   # check for special devices/clients:   # check for special devices/clients:
270   # check for laptops and activate cpufreq scaling   # check for laptops and activate cpufreq scaling
271   if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]   if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]
# Line 318  run_hardware_detection_disks() Line 282  run_hardware_detection_disks()
282   # all disks but exclude ramdisks   # all disks but exclude ramdisks
283   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
284   # remove the boot device from ALL_DISKS if it was an usbstick   # remove the boot device from ALL_DISKS if it was an usbstick
285   if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]   if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
286   then   then
287   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
288   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
289   fi   fi
290   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
291  }  }
292    
293  setup_hdd_partitions_auto()  setup_hdd_partitions()
294  {  {
  ROOTHDD="${HDD}1"  
   
295   # sanity check - should not happen   # sanity check - should not happen
296   if is_mounted --device "${ROOTHDD}"   if is_mounted --device "${ROOTHDD}"
297   then   then
298   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
299   umount "${ROOTHDD}"   umount "${ROOTHDD}"
300   fi   fi
301     if [[ -n ${BOOTHDD} ]]
  # run this only if FDISKPARTITIONBELOW256MB is not already 1  
  if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]  
302   then   then
303   if hdd_size_below_256mb ${HDD}   if is_mounted --device "${BOOTHDD}"
304   then   then
305   FDISKPARTIONBELOW256MB=1   echo "partition: device ${BOOTHDD} is already mounted, umount it" >&2
306   else   umount "${BOOTHDD}"
  FDISKPARTIONBELOW256MB=0  
307   fi   fi
308   fi   fi
309    
310   ## delete disk   if [[ ${INSTALL_METHOD} = auto ]]
  dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die  
   
  if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]  
311   then   then
312   ## setup one bootable partition   # run this only if FDISKPARTITIONBELOW256MB is not already 1
313   #1. n= new disk   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
314   #2. p= primary disk   then
315   #3. 1= first partition   if device_minimum_size "${HDD}" 256
316   #4. 2= default sector start // small disk needs more space for grub2 mbr sector   then
317   #5. ''= defaul sector end   FDISKPARTIONBELOW256MB=1
318   #6. a= bootable flag   else
319   #7. 1= boot flag for partition 1   FDISKPARTIONBELOW256MB=0
320   #8. w= write/quit   fi
321   fdisk ${HDD} &> /dev/null << EOF   fi
322    
323     ## delete disk
324     dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
325    
326     if [[ ${FLASHDISK} = 1 ]]
327     then
328     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
329     then
330     ## setup one bootable partition
331     # 1. n= new disk
332     # 2. p= primary disk
333     # 3. 1= first partition
334     # 4. 2= default sector start // small disk needs more space for grub2 mbr sector
335     # 5. ''= defaul sector end
336     # 6. a= bootable flag
337     # 7. 1= boot flag for partition 1
338     # 8. n= new disk
339     #10. p= primary disk
340     #11. 2= second partition
341     #12. ''= default sector start
342     #13. ''= defaul sector end
343     #14. w= write/quit
344     fdisk ${HDD} &> /dev/null << EOF
345  n  n
346  p  p
347  1  1
348  2  2
349    +50M
350  a  a
351  1  1
352    n
353    p
354    2
355    
356    
357  w  w
358  EOF  EOF
359   else   else
360   ## setup one bootable partition   ## setup one bootable partition
361   #1. n= new disk   # 1. n= new disk
362   #2. p= primary disk   # 2. p= primary disk
363   #3. 1= first partition   # 3. 1= first partition
364   #4. ''= default sector start   # 4. ''= default sector start
365   #5. ''= defaul sector end   # 5. ''= defaul sector end
366   #6. a= bootable flag   # 6. a= bootable flag
367   #7. 1= boot flag for partition 1   # 7. 1= boot flag for partition 1
368   #8. w= write/quit   # 8. n= new disk
369   fdisk ${HDD} &> /dev/null << EOF   #10. p= primary disk
370     #11. 2= second partition
371     #12. ''= default sector start
372     #13. ''= defaul sector end
373     #14. w= write/quit
374     fdisk ${HDD} &> /dev/null << EOF
375  n  n
376  p  p
377  1  1
378    
379    +50M
380    a
381    1
382    n
383    p
384    2
385    
386    
387    w
388    EOF
389     fi
390     else
391     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
392     then
393     ## setup one bootable partition
394     #1. n= new disk
395     #2. p= primary disk
396     #3. 1= first partition
397     #4. 2= default sector start // small disk needs more space for grub2 mbr sector
398     #5. ''= defaul sector end
399     #6. a= bootable flag
400     #7. 1= boot flag for partition 1
401     #8. w= write/quit
402     fdisk ${HDD} &> /dev/null << EOF
403    n
404    p
405    1
406    2
407    
408  a  a
409  1  1
410  w  w
411  EOF  EOF
412   fi   else
413  }   ## setup one bootable partition
414     #1. n= new disk
415     #2. p= primary disk
416     #3. 1= first partition
417     #4. ''= default sector start
418     #5. ''= defaul sector end
419     #6. a= bootable flag
420     #7. 1= boot flag for partition 1
421     #8. w= write/quit
422     fdisk ${HDD} &> /dev/null << EOF
423    n
424    p
425    1
426    
 setup_hdd_partitions_manual()  
 {  
  ROOTHDD="${HDD}1"  
  SWAPHDD=""  
  BOOTHDD=""  
  cfdisk ${HDD} || dialog_die  
 }  
427    
428  setup_hdd_format()  a
429  {  1
430   # sanity check - should not happen  w
431   if is_mounted --device "${ROOTHDD}"  EOF
432   then   fi
433   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2   fi
434   umount "${ROOTHDD}"   else
435     cfdisk ${HDD} || dialog_die
436   fi   fi
   
  mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die  
437  }  }
438    
439  install_mount_rootfs()  setup_hdd_format()
 {  
  is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"  
  install -d ${INSTALLROOT}/boot || dialog_die  
 }  
   
 install_system_image()  
 {  
  pushd ${INSTALLROOT} > /dev/null  
  tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}  
  popd > /dev/null  
 }  
   
 disabled_install_bootsector_chroot()  
440  {  {
441   local my_roothdd   install -d /tmp
442   local grubconf="${INSTALLROOT}/boot/grub/grub.conf"   :> /tmp/format.log
  local grub2conf="/boot/grub/grub.cfg"  
443    
444   # check for grub2   if [[ -n ${SWAPHDD} ]]
  if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]  
445   then   then
446   # needed by grub-mkconfig on the first run   # sanity check - should not happen
447   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]   if is_mounted --device "${SWAPHDD}"
448   then   then
449   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die   echo "format: device ${SWAPHDD} is already mounted, umount it" >&2
450     umount "${SWAPHDD}"
451   fi   fi
452     mkswap ${SWAPHDD} || die
453     fi
454    
455   # set kernelopts   if [[ -n ${BOOTHDD} ]]
456   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]   then
457   then   # sanity check - should not happen
458   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die   if is_mounted --device "${BOOTHDD}"
  else  
  CONFIG="${INSTALLROOT}/etc/conf.d/grub"  
  clearconfig  
  addconfig "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\""  
  fi  
  CONFIG="${INSTALLROOT}/root/.installrc"  
  clearconfig  
  # only grub 1.99  
  addconfig 'type -P grub-mkdevicemap && grub-mkdevicemap'  
  addconfig "grub-install --no-floppy ${HDD} &> /dev/null"  
  addconfig "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null"  
  addconfig "exit 0"  
   
  # grub-legacy  
  else  
  source ${INSTALLROOT}/boot/kernelversion  
   
  if [ -e ${INSTALLROOT}/etc/alx_version ]  
  then  
  OLD_ALXVER="${ALXVER}"  
  source ${INSTALLROOT}/etc/alx_version  
  KRNVER="ALX-${ALXVER}"  
  ALXVER="${OLD_ALXVER}"  
  fi  
   
  [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"  
  [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"  
  [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"  
   
  # uuid support  
  my_roothdd="UUID=$(get_uuid ${ROOTHDD})"  
   
  CONFIG="${grubconf}"  
  clearconfig  
  addconfig "default 0"  
  addconfig "timeout 3"  
  # using current root password  
  addconfig "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  
   
  addconfig  
  addconfig "# normal boot"  
  addconfig "title ${KRNVER}"  
  addconfig "root (hd0,0)"  
  addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}"  
  if is_initrd_supported  
459   then   then
460   addconfig "initrd /boot/${KRNINITRD}"   echo "format: device ${BOOTHDD} is already mounted, umount it" >&2
461     umount "${BOOTHDD}"
462   fi   fi
463    
464   addconfig   mkfs."${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" &>> /tmp/format.log || dialog_die
465   addconfig "# admin boot"   fi
  addconfig "title ${KRNVER} - Re-run hardware-detection"  
  addconfig "lock"  
  addconfig "root (hd0,0)"  
  addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection"  
  if is_initrd_supported  
  then  
  addconfig "initrd /boot/${KRNINITRD}"  
  fi  
466    
467   addconfig   if [[ -n ${ROOTHDD} ]]
468   addconfig "title ${KRNVER} - Reset *all* local settings"   then
469   addconfig "lock"   # sanity check - should not happen
470   addconfig "root (hd0,0)"   if is_mounted --device "${ROOTHDD}"
  addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings"  
  if is_initrd_supported  
471   then   then
472   addconfig "initrd /boot/${KRNINITRD}"   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
473     umount "${ROOTHDD}"
474   fi   fi
475    
476   # bootsector schreiben chrooted schreiben (lfs/magellan)   mkfs."${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" &>> /tmp/format.log || dialog_die
  cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  
 /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  
 root (hd0,0)  
 setup (hd0)  
 quit  
 EOF  
 exit 0  
 CHROOTEOF  
477   fi   fi
478    }
479    
480   # run installrc  install_system_image()
481   chrooted /bin/bash --rcfile /root/.installrc -i  {
482   rm ${INSTALLROOT}/root/.installrc   pushd ${INSTALLROOT} > /dev/null
483  }   tar xvjpf ${IMAGEROOT}/${CDIMAGENAME} -C ${INSTALLROOT}
484     popd > /dev/null
 disabled_install_initrd_chroot()  
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
   
  DISKMODS="sd_mod"  
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
   
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"  
  fi  
   
  # install an appropriate uvesafb.conf  
  install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die  
  CONFIG="${INSTALLROOT}/etc/modprobe.d/uvesafb.conf"  
  clearconfig  
  addconfig "options uvesafb mode_option=1024x768-32@60 scroll=ywrap"  
   
  # install an appropriate viafb.conf  
  CONFIG="${INSTALLROOT}/etc/modprobe.d/viafb.conf"  
  clearconfig  
  addconfig "options viafb viafb_mode=1024x768 viafb_refresh=60"  
   
  # install an appropriate i810fb.conf  
  CONFIG="${INSTALLROOT}/etc/modprobe.d/i810fb.conf"  
  clearconfig  
  addconfig "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  
   
  cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  
 echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  
 mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  
 exit 0  
 CHROOTEOF  
   
  # run installrc  
  chrooted /bin/bash --rcfile /root/.installrc -i  
  rm ${INSTALLROOT}/root/.installrc  
485  }  }
486    
487  install_system_settings()  install_system_settings()
# Line 593  install_system_settings() Line 491  install_system_settings()
491   # write fstab   # write fstab
492   CONFIG="${INSTALLROOT}/etc/fstab"   CONFIG="${INSTALLROOT}/etc/fstab"
493   clearconfig   clearconfig
494   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"   if [[ -n ${BOOTHDD} ]]
495     then
496     addconfig -e "UUID=$(get_uuid ${BOOTHDD})\t/\t${FORMAT_FILESYSTEM_BOOTHDD}\tnoatime\t1 1"
497     fi
498     if [[ -n ${ROOTHDD} ]]
499     then
500     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM_ROOTHDD}\tnoatime\t0 0"
501     fi
502     if [[ -n ${SWAPHDD} ]]
503     then
504     addconfig -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0"
505     fi
506   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
507   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
508    
# Line 604  install_system_settings() Line 513  install_system_settings()
513   addconfig 'NETWORKING="dhcp"'   addconfig 'NETWORKING="dhcp"'
514    
515   # intel framebuffer quirk   # intel framebuffer quirk
516   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]   CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
517     if [ -e ${CONFIG} ] && [ -e /proc/fb ]
518   then   then
519   if [ -e /proc/fb ]   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
520   then   then
521   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
522   then   [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
  fi  
523   fi   fi
524   fi   fi
525  }  }
526    
527  install_umount_rootfs()  
528    ### installer dialogs ###
529    
530    dialog_die()
531  {  {
532   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot   ERROR="$1"
533   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}   RETVAL="$?"
534     dialog_install_failure
535     exit 1
536  }  }
537    
538  install_do_reboot()  dialog_warning()
539  {  {
540   reboot   local retval
541    
542     yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
543     retval=$?
544     if [[ ${retval} -eq 1 ]]
545     then
546     clear
547     echo $"The process was aborted."
548     exit 1
549     fi
550  }  }
551    
 #################################################  
 #     Install Ablauf Scripte #  
 #################################################  
552    
553  run_install_normal()  ### installer tasks ###
554    
555    task_setup_system_menu()
556  {  {
557   dialog_hardware_detection   local mode
558     local retval
559    
560   task_setup_hdd_partitions_manual   mode="$(dialog_setup_system_menu)"
561   dialog_setup_hdd_format   retval=$?
562   setup_hdd_format > /dev/null   [[ ${retval} -eq 1 ]] && return 1
563   install_mount_rootfs   if [[ ${retval} -eq 0 ]]
564   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   then
565     case "${mode}" in
566     "1") run_install auto ;;
567     "2") run_install normal ;;
568     "") task_setup_system_menu;;
569     esac
570     fi
571    }
572    
573   dialog_install_settings  task_hardware_detection()
574   sleep 1  {
575   install_system_settings   local message
576   if is_initrd_supported  
577     run_hardware_detection_disks
578    
579     message+=$"Harddrives:\n"
580    
581     if [[ ! -z ${ALL_DISKS} ]]
582   then   then
583   dialog_install_initrd   for i in ${ALL_DISKS}
584   initrd_config   do
585   initrd_install   message+="\Z3${i}\Zn "
586     done
587     message+="\n"
588   fi   fi
589    
590   dialog_install_bootsector   if [[ ! -z ${ALL_CDROMS} ]]
591   bootloader_config   then
592   bootloader_install   message+="\n"
593     message+=$"Optical disk drives:\n"
594     for i in ${ALL_CDROMS}
595     do
596     message+="\Z3${i}\Zn"
597     done
598     message+="\n"
599     fi
600    
601   install_umount_rootfs   # other devices
602   dialog_install_successful   run_hardware_detection
603     case "${SPECIALDEVICE}" in
604     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
605     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
606     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
607     i845) message+=$"\n\Z2Intel i845 VGA device detected.\Zn" ;;
608     nomsi) message+=$"\n\Z2Mainboard with P5VD2-X/VT8237/VX700 chipset detected.\Zn"
609     message+=$"\n\Z2Disabling Message Signaled Interrupts (MSI) capability of the kernel.\Zn" ;;
610     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
611     esac
612     if [[ ${FORMFACTOR} = laptop ]]
613     then
614     message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
615     fi
616     if [[ ${FLASHDISK} = 1 ]]
617     then
618     message+=$"\n\ZnFlash memory detected.\Zn"
619     message+=$"\n\ZnF2FS will be used as default filesystem withn the auto installation mode.\Zn"
620     fi
621    
622     messagebox -y 12 -h $"Detected hardware:" "${message}"
623    }
624    
625    task_select_target_hdd()
626    {
627     if [[ -z ${ALL_DISKS} ]]
628     then
629     dialog_no_harddrive_found
630     exit 1
631     else
632     export HDD=$(dialog_select_target_harddrive)
633     fi
634    }
635    
636    task_setup_hdd_partitions()
637    {
638     local retval
639    
640     if [[ -z ${HDD} ]]
641     then
642     dialog_no_harddrive_found
643     exit 1
644     else
645     dialog_setup_hdd_info
646     setup_hdd_partitions
647     fi
648    }
649    
650    task_main()
651    {
652     local method=0
653     local retval
654    
655     while [[ ${method} -le 2 ]]
656     do
657     method=$(dialog_main)
658     retval=$?
659     [[ ${retval} -eq 1 ]] && exit 1
660     if [[ ${retval} -eq 0 ]]
661     then
662     case ${method} in
663     "1") task_setup_system_menu ;;
664     "2") task_hardware_detection ;;
665     "3") install_do_reboot ;;
666     "4") /bin/bash --login -i ;;
667     esac
668     fi
669     done
670  }  }
671    
672  run_install_auto()  run_install()
673  {  {
674   dialog_hardware_detection   local method="$1"
675    
676     task_hardware_detection
677     task_select_target_hdd
678    
679     case "${method}" in
680     auto)
681     if [[ ${FLASHDISK} = 1 ]]
682     then
683     export BOOTHDD="${HDD}1"
684     export SWAPHDD=""
685     export ROOTHDD="${HDD}2"
686     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
687     export FORMAT_FILESYSTEM_ROOTHDD="f2fs"
688     else
689     # ext4 seems not to be compatible again
690     if [[ ${FORMAT_FILESYSTEM} = ext4 ]]
691     then
692     export BOOTHDD="${HDD}1"
693     export SWAPHDD=""
694     export ROOTHDD="${HDD}2"
695     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
696     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
697     else
698     export BOOTHDD=""
699     export SWAPHDD=""
700     export ROOTHDD="${HDD}1"
701     export FORMAT_FILESYSTEM_BOOTHDD=""
702     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
703     fi
704     fi
705     export INSTALL_METHOD="${method}"
706     ;;
707     normal)
708     export BOOTHDD="${HDD}1"
709     export SWAPHDD="${HDD}2"
710     export ROOTHDD="${HDD}3"
711     export FORMAT_FILESYSTEM_BOOTHDD="${FORMAT_FILESYSTEM}"
712     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
713     export INSTALL_METHOD="${method}"
714     ;;
715     single)
716     export BOOTHDD=""
717     export SWAPHDD=""
718     export ROOTHDD="${HDD}1"
719     export FORMAT_FILESYSTEM_BOOTHDD=""
720     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
721     export INSTALL_METHOD="${method}"
722     ;;
723     flash)
724     export BOOTHDD="${HDD}1"
725     export SWAPHDD=""
726     export ROOTHDD="${HDD}2"
727     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
728     export FORMAT_FILESYSTEM_ROOTHDD="f2fs"
729     export INSTALL_METHOD="${method}"
730     ;;
731     *)
732     die "Unknown install method '${method}', aborting."
733     ;;
734     esac
735    
736   task_setup_hdd_partitions_auto   task_setup_hdd_partitions
737   dialog_setup_hdd_format   dialog_setup_hdd_format
738   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
739   install_mount_rootfs   mount_rootfs
740   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
741    
742   dialog_install_settings   dialog_install_settings
# Line 687  run_install_auto() Line 753  run_install_auto()
753   bootloader_config   bootloader_config
754   bootloader_install   bootloader_install
755    
756   install_umount_rootfs   umount_rootfs
757   dialog_install_successful   dialog_install_successful
758  }  }
759    

Legend:
Removed from v.2479  
changed lines
  Added in v.2941